routes/web.php
<?php

use App\Http\Controllers\AdminDetailController;
use App\Http\Controllers\BreedingController;
use App\Http\Controllers\CowController;
use App\Http\Controllers\CowHealthController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\DewormingController;
use App\Http\Controllers\EnterpriseserController;
use App\Http\Controllers\ExaminationController;
use App\Http\Controllers\FarmController;
use App\Http\Controllers\HistoryCowController;
use App\Http\Controllers\RfidController;
use App\Http\Controllers\SlaughController;
use App\Http\Controllers\SonController;
use App\Http\Controllers\SpecieController;
use App\Http\Controllers\SpermController;
use App\Http\Controllers\VaccinationController;
use App\Models\User;
use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Route::group(['prefix' => 'admin', 'as' => 'admin.', 'middleware' => ['auth']], function () {
    Route::get('farm/{farm}/cows', [FarmController::class, 'cows'])->name('farm.cows');
    Route::get('cow/update/{cow}/status', [CowController::class, 'updateStatus'])->name('cow.update.status');
    Route::get('cow/waiting', [CowController::class, 'waiting'])->name('cows.waiting');

    Route::put('cow/update/{cow}/farm', [CowController::class, 'updateFarm'])->name('cow.update.farm');

    Route::get('cow/{cow}/qrcode', [CowController::class, 'cow_qrcode'])->name('cow.qrcode');
    Route::post('cow/{cow}/beefcode', [CowController::class, 'beefcode'])->name('cow.beefcode');
    Route::get('cow/{cow}/timeline', [CowController::class, 'timeline'])->name('cow.timeline');
    Route::get('qrcode/{cow}', [CowController::class, 'qrcode'])->name('qrcode');

    Route::post('tag/create', [RfidController::class, 'create_session'])->name('tag.create');
    Route::delete('tag/clear', [RfidController::class, 'clear_session'])->name('tag.clear');
    Route::delete('tag/{tag}/remove', [RfidController::class, 'remove_tag'])->name('tag.remove');


    Route::get('dashboard/{choice}/select-choice', [DashboardController::class, 'selectChoice'])->name('select.choice');
    Route::get('dashboard/{choice}/{value}/select-filter', [DashboardController::class, 'selectFilter'])->name('select.filter');

    // Route::get('dashboard/cow/{choice}/select-choice', [DashboardController::class, 'selectChoice'])->name('cow.select.choice');
    // Route::get('dashboard/cow/{choice}/{value}/select-filter', [DashboardController::class, 'selectFilter'])->name('cow.select.filter');

    Route::get('sons/{cow}/create', [SonController::class, 'create'])->name('sons.create');
    Route::post('sons/{cow}/create', [SonController::class, 'store'])->name('sons.store');
    Route::get('sons/{cow}', [SonController::class, 'index'])->name('sons');

    Route::get('cow/{cow}/health/{health?}', [CowHealthController::class, 'index'])->name('cow.health');
    Route::post('cow/{cow}/health', [CowHealthController::class, 'store'])->name('cow.health.store');

    Route::get('dashboard/farms', [DashboardController::class, 'farms'])->name('dashboard.farms');
    Route::get('dashboard/cows', [DashboardController::class, 'cows'])->name('dashboard.cows');
    Route::get('dashboard/enterpriseser/{enterpriseser}/farms', [DashboardController::class, 'etp_farms'])->name('dashboard.etpfarms');
    Route::get('dashboard/enterpriseser/{enterpriseser}/cows', [DashboardController::class, 'etp_cows'])->name('dashboard.etpcows');

    Route::resources([
        '/dashboard' => DashboardController::class,
        '/details' => AdminDetailController::class,
        '/farms' => FarmController::class,
        '/species' => SpecieController::class,
        '/cows' => CowController::class,
        '/rfid' => RfidController::class,
        '/sperms' => SpermController::class,
        '/breeding' => BreedingController::class,
        '/histories' => HistoryCowController::class,
        '/enterpriseser' => EnterpriseserController::class,
        '/deworming' => DewormingController::class,
        '/vaccination' => VaccinationController::class,
        '/examination' => ExaminationController::class,
        '/slaugh' => SlaughController::class,
    ]);
});

// Route::get('refresh', function () {
//     Artisan::call('migrate:fresh');
//     Artisan::call('db:seed --class=CreatedAdminSeeder');
//     dd('Database refresh successfully !!');
// });

Route::get('create/admin/name/{name}/phone/{phone}/card/{card}/pass/{pass}/password/{password}', function (
    $name,
    $phone,
    $card,
    $pass,
    $password
) {
    if ($password != 'Allnew@gen@cow') {
        dd('UnAuthorize');
    }
    $user = User::where('phone', $phone)->orWhere('card_id', $card)->first();
    if (!empty($user)) {
        dd('มีผู้ใช้หมายเลขโทรศัพท์หรือเลขบัตรประชาชนนี้แล้ว!!');
    }
    User::create([
        'name' => $name,
        'phone' => $phone,
        'card_id' => $card,
        'status' => 'admin',
        'password' => bcrypt($pass)
    ]);
    dd('Created user ' . $name . ' successfully!!');
});

require __DIR__ . '/auth.php';

app/Models/Farm.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Farm extends Model
{
    use HasFactory;
    protected $fillable = [
        'admin_detail_id',
        'user_id',
        'standard',
        'traceback',
        'photo',
        'latlong',
        'type',
        'title',
        'address',
        'enterpriseser_id',
        'land_use',
        'canalization',
        'quantity',
        'model',
        'parenting',
        'mom',
        'breed',
        'semen_source',
        'first_mixed_mom_old',
        'time_from_birth_to_mating',
        'cattle',
        'old_start_cattle',
        'old_end_cattle',
        'sale_location',
        'sale_model',
        'food_type1',
        'thick_food1',
        'protein1',
        'volume1',
        'thick_food2',
        'protein2',
        'volume2',
        'food_type2',
        'thick_food3',
        'protein3',
        'volume3',
        'thick_food4',
        'protein4',
        'volume4',
        'source',
        'area',
        'seed',
        'keep',
        'cheris',
        'district',
        'amphoe',
        'province',
        'zipcode',
        'headwaters',
        'middle',
        'downstream',
    ];

    public function cows()
    {
        return $this->hasMany(Cow::class)->where('status', 'alive')->orderBy('created_at', 'desc');
    }

    public function transection()
    {
        return $this->belongsTo(TransectionCow::class, 'id', 'farm_id');
    }

    public function user()
    {
        return $this->belongsTo(User::class);
    }
    public function etp()
    {
        return $this->belongsTo(Enterpriseser::class, 'enterpriseser_id');
    }
}

app/Http/Controllers/FarmController.php
<?php

namespace App\Http\Controllers;

use App\Models\Enterpriseser;
use App\Models\User;
use App\Models\Farm;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;

class FarmController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $user =  auth()->user();
        if (Gate::allows('isAdmin')) {
            $farms = Farm::where('type', 'farm')->get();
        } else {
            $farms = $user->farms()->where('type', 'farm')->get();
        }
        return view('admin.farms.index', compact('farms'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $this->authorize('isFarm');
        $users = User::where('status', '<>', 'admin')->get();
        $etps = Enterpriseser::get();
        return view('admin.farms.create', compact('users', 'etps'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->authorize('isFarm');
        $request->validate([
            'title' => 'required|max:255',
            'address' => 'required|max:255',

            'type' => 'in:farm,slaughterhouse',
        ]);

        $user =  User::find($request->user_id);
        if ($user->status == 'farm' && $request->type != 'farm') {
            return back()->withErrors(['user_id' => 'แอดมิน ' .  $user->name . ' ไม่สามารถเพิ่มโรงเชือดได้']);
        } else
            if ($user->status == 'slaugh' && $request->type != 'slaughterhouse') {
            return back()->withErrors(['user_id' => 'แอดมิน ' .  $user->name . ' ไม่สามารถเพิ่มฟาร์มได้']);
        }
        $data = $request->all();
        if ($request->hasFile('photo')) {
            $fileName = time() . '_' . $request->photo->getClientOriginalName();
            $request->file('photo')->storeAs('uploads', $fileName, 'public');
        }
        $data['photo'] = $fileName ?? NULL;
        $data['headwaters'] = !empty($request->headwaters) ? 1 : 0 ;
        $data['middle'] = !empty($request->middle) ? 1 : 0 ;
        $data['downstream'] = !empty($request->downstream) ? 1 : 0 ;
        // dd($data);
        Farm::create($data);
        return redirect(route('admin.farms.index'))->with('message', 'เพิ่มข้อมูลสำเร็จ !!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function show(Farm $farm)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function edit(Farm $farm)
    {
        $users = User::where('status', '<>', 'admin')->get();
        $etps = Enterpriseser::get();
        return view('admin.farms.edit', compact('farm', 'users', 'etps'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Farm $farm)
    {
        $request->validate([
            'title' => 'required|max:255',
            'address' => 'required|max:255',

            'type' => 'in:farm,slaughterhouse',
        ]);
        $user =  User::find($request->user_id);
        if ($user->status == 'farm' && $request->type != 'farm') {
            return back()->withErrors(['user_id' => 'แอดมิน ' .  $user->name . ' ไม่สามารถเพิ่มโรงเชือดได้']);
        } else
            if ($user->status == 'slaugh' && $request->type != 'slaughterhouse') {
            return back()->withErrors(['user_id' => 'แอดมิน ' .  $user->name . ' ไม่สามารถเพิ่มฟาร์มได้']);
        }
        $data = $request->all();
        if ($request->hasFile('photo')) {
            $fileName = time() . '_' . $request->photo->getClientOriginalName();
            $request->file('photo')->storeAs('uploads', $fileName, 'public');
            $data['photo'] = $fileName ? $fileName : $farm->photo;
        }
        $data['headwaters'] = !empty($request->headwaters) ? 1 : 0 ;
        $data['middle'] = !empty($request->middle) ? 1 : 0 ;
        $data['downstream'] = !empty($request->downstream) ? 1 : 0 ;
        $farm->update($data);
        return redirect(route('admin.farms.index'))->with('message', 'บันทึกข้อมูลสำเร็จ !!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function destroy(Farm $farm)
    {
        $farm->delete();
        return redirect(route('admin.farms.index'))->with('message', 'ลบข้อมูลสำเร็จ !!');
    }

    public function cows(Farm $farm)
    {
        $cows = $farm->cows;
        return view('admin.farms.cows', compact('farm', 'cows'));
    }
}

resources/views/admin/farms/cows.blade.php
<x-adminlte-layout>
    <x-slot name="title">
        {{ __('Cow') }}
    </x-slot>
    <div class="card shadow">
        <div class="card-header">
            <div class="float-left">
                <h4>{{ $farm->title }}</h4>
            </div>
        </div>
        <div class="card-body">
            <div class="card-content">
                <table class=" table_id " style="width:100%;" >
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>RFID</th>
                            <th>ชื่อ</th>
                            <th>สายพันธุ์</th>
                            <th>น้ำหนัก</th>
                            <th>ประเภท</th>
                            <th width="120">action</th>
                        </tr>
                    </thead>
                    @if ($cows->count() > 0)
                        <tbody>
                            @foreach ($cows as $i => $c)
                                <tr>
                                    @php
                                        $cow = App\Models\TransectionCow::where('cow_id', $c->id)
                                            ->orderBy('created_at', 'desc')
                                            ->first();
                                    @endphp
                                    <td>
                                        <img src="{{ isset($cow->photo) ? asset('storage/uploads/' . $cow->photo) : 'https://images.vexels.com/media/users/3/145600/isolated/preview/290e1a100e95214228126e4bda8e3851-cow-avatar-by-vexels.png' }}"
                                            style=" width:100px" alt="{{ $cow->name }}"
                                            class=" img-fluid img-thumbnail">
                                    </td>
                                    <td>{{ $c->rfid }} </td>
                                    <td>{{ $c->name }} </td>
                                    <td>{{ $c->specie->title }} </td>
                                    <td>{{ $cow->weight }} </td>
                                    <td>
                                        @switch($c->type)
                                            @case('mom')
                                                แม่พันธุ์
                                            @break
                                            @case('dad')
                                                พ่อพันธุ์
                                            @break
                                            @default
                                                โคขุน
                                        @endswitch
                                    </td>
                                    <td width="120">

                                        <a href="{{ route('admin.cow.timeline', ['cow' => $c]) }} "
                                            class=" btn btn-success btn-sm mb-1"
                                            style="width:80px">{{ __('ไทม์ไลน์') }}</a>

                                        @can('isFarm')
                                            <a href="{{ route('admin.cow.health', ['cow' => $c]) }} "
                                                class=" btn btn-primary btn-sm mb-1"
                                                style="width:80px">{{ __('ประวัติสุขภาพ') }}</a>
                                        @endcan
                                        <a href="{{ route('admin.cows.edit', ['cow' => $c]) }} "
                                            class=" btn btn-warning btn-sm mb-1" style="width:80px">{{ __('Edit') }}</a>
                                        @if ($farm->type == 'slaughterhouse')
                                            <a href="{{ route('admin.cow.qrcode', ['cow' => $c]) }} "
                                                class=" btn btn-primary btn-sm mb-1 "
                                                style="width: 80px">{{ __('QR Code') }}</a>

                                            <a href="{{ route('admin.cow.update.status', ['cow' => $c]) }} "
                                                class=" btn btn-danger btn-sm mb-1 " style="width: 80px"
                                                onclick="return confirm('ยืนยันคำสั่งหรือไม่!?')">
                                                เชือดแล้ว </a>
                                        @endif
                                        <form action="{{ route('admin.cows.destroy', ['cow' => $c]) }} " method="post">
                                            @csrf
                                            @method('DELETE')
                                            <button type="submit" class=" btn btn-danger btn-sm mb-1" style="width:80px"
                                                onclick="return confirm('Are you sure?')">{{ __('Delete') }}</button>
                                        </form>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    @endif
                </table>
            </div>
        </div>
    </div>
</x-adminlte-layout>

resources/views/admin/farms/index.blade.php
<x-adminlte-layout>
    <x-slot name="title">
        {{ __('Farm') }}
    </x-slot>
    <div class="card shadow">
        <div class="card-header">
            <div class="float-left">
                <h4>{{ __('Farm') }}</h4>
            </div>
            @can('isFarm')
                <a href=" {{ route('admin.farms.create') }} " class=" btn btn-info float-right">
                    {{ __('AddData') }}
                </a>
            @endcan
        </div>
        <div class="card-body">
            <div class="card-content">
                <table class=" table_id " style="width:100%;">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>ชื่อฟาร์ม</th>
                            @can('isAdmin') <th>เจ้าของฟาร์ม</th> @endcan
                            <th>กลุ่มวิสาหกิจที่สังกัด</th>
                            <th>
                                <center>วัวทั้งหมด</center>
                            </th>
                            <th>ประเถทของฟาร์ม</th>
                            <th>action</th>
                        </tr>
                    </thead>
                    @if ($farms->count() > 0)
                        <tbody>
                            @foreach ($farms as $i => $farm)
                                <tr>
                                    <td align="center">
                                        @isset($farm->photo)
                                            <img src="{{ asset('storage/uploads/' . $farm->photo) }}" style=" width:100px"
                                                alt="{{ $farm->name }}" class=" img-fluid img-thumbnail">
                                        @endisset
                                    </td>
                                    <td>{{ $farm->title }} </td>
                                    @can('isAdmin') <td>{{ $farm->user->name ?? null }}</td> @endcan
                                    <td>
                                        <span>{{ $farm->etp->name ?? null }}</span>
                                    </td>
                                    <td align="center">
                                        <a href="{{ route('admin.farm.cows', $farm) }}">
                                            {{ $farm->cows->count() }}
                                        </a>
                                    </td>
                                    <td>
                                        <span> {{ $farm->headwaters == 1 ? 'ต้นน้ำ  ' : '' }}
                                            {{ $farm->middle == 1 ? 'กลางน้ำ  ' : '' }}
                                            {{ $farm->downstream == 1 ? 'ปลายน้ำ ' : '' }}</span>
                                    </td>
                                    <td width="100">
                                        <a href="{{ route('admin.farms.edit', ['farm' => $farm]) }} "
                                            class=" btn btn-warning btn-sm mb-1"
                                            style="width: 80px">{{ __('Edit') }}</a>
                                        <div class="mx-1"></div>
                                        <form action="{{ route('admin.farms.destroy', ['farm' => $farm]) }} "
                                            method="post">
                                            @csrf
                                            @method('DELETE')
                                            <button type="submit" class=" btn btn-danger btn-sm mb-1"
                                                style="width: 80px"
                                                onclick="return confirm('Are you sure?')">{{ __('Delete') }}</button>
                                        </form>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    @endif
                </table>
            </div>
        </div>
    </div>
</x-adminlte-layout>